<template>
  <div class="screen">
    <div class="menu">
      <q-tabs vertical>
        <q-route-tab
          class="text-cyan"
          icon="manage_accounts"
          :to="{ name: RouteName.STAFF }"
        >
          <q-tooltip
            anchor="center right"
            self="center left"
            transition-show="jump-right"
            transition-hide="jump-left"
          >
            設定資料
          </q-tooltip>
        </q-route-tab>
        <q-route-tab
          class="text-primary"
          icon="date_range"
          :to="{ name: RouteName.ITINERARY }"
        >
          <q-tooltip
            anchor="center right"
            self="center left"
            transition-show="jump-right"
            transition-hide="jump-left"
          >
            排定職缺
          </q-tooltip>
        </q-route-tab>
        <q-route-tab
          class="text-secondary"
          icon="account_circle"
          :to="{ name: RouteName.ROSTER }"
        >
          <q-tooltip
            anchor="center right"
            self="center left"
            transition-show="jump-right"
            transition-hide="jump-left"
          >
            開始排班
          </q-tooltip>
        </q-route-tab>
        <q-route-tab
          class="text-deep-orange"
          icon="source"
          :to="{ name: RouteName.CLASS_SCHEDULE }"
        >
          <q-tooltip
            anchor="center right"
            self="center left"
            transition-show="jump-right"
            transition-hide="jump-left"
          >
            查看班表
          </q-tooltip>
        </q-route-tab>
      </q-tabs>
    </div>
    <router-view v-slot="{ Component }">
      <transition
        name="scale-in"
        mode="out-in"
      >
        <component :is="Component" />
      </transition>
    </router-view>
  </div>
</template>

<script setup lang="ts">
import { RouteName } from './router/router';

import DialogPreferences from './components/dialog-preferences.vue';

import { useQuasar, useMeta } from 'quasar';
import { useMainStore } from './store/main.store';

const $q = useQuasar();
const store = useMainStore();

function init() {
  store.init();
  store.$subscribe((mutation, state) => {
    Object.entries(state).forEach(([key, value]) => {
      localStorage.setItem(`class-table-helper:${key}`, JSON.stringify(value));
    });
  })

}
init();

function openPreferences() {
  $q.dialog({
    component: DialogPreferences,
  });
}


useMeta(() => ({
  title: `Class Table Helper`,
  titleTemplate: (title) => `${title} v${import.meta.env.PACKAGE_VERSION}`,
}));

</script>

<style lang="sass">
html, body, #app, .screen
  width: 100%
  height: 100%
  padding: 0px
  margin: 0px

.screen
  display: flex
  .page
    width: 100%
    height: 100%

.menu
  display: flex
  flex-direction: column

.preferences
  height: 60px !important
</style>
